/*
 * The SPA Controller exposes a single-page app on a given path,
 * statically built using Webpack, or served by Webpack-Dev-Server in development
 */
const ControllerREST = function ControllerREST(config) {
    return ({
        name: 'ControllerREST',
        async initialize({ logger, server }) {
            const { path, routes, } = config;
            const prefix = path.endsWith('/') ? path.slice(0, -1) : path;
            server.register((instance) => {
                ['get', 'post', 'put', 'delete', 'options', 'patch', 'head']
                    .forEach((method) => {
                    if (routes[method]) {
                        Object.keys(routes[method])
                            .forEach((route) => {
                            const routePath = route.startsWith('/') ? route : `/${route}`;
                            logger.info(`Registering handler for ${method}:${prefix}${routePath}`);
                            if ('options' in routes[method][route]) {
                                instance[method](routePath, routes[method].options, routes[method].handler);
                            }
                            else {
                                instance[method](routePath, routes[method][route]);
                            }
                        });
                    }
                });
            }, { prefix });
        },
    });
};
export default ControllerREST;
