import { RouteOptions, RouteShorthandOptions } from 'fastify';
import { Controller } from '@harmonyjs/types-server';
declare type HttpMethod = 'get' | 'post' | 'put' | 'delete' | 'options' | 'patch' | 'head';
declare type ControllerRESTRoute = RouteOptions['handler'] | {
    options: RouteShorthandOptions;
    handler: RouteOptions['handler'];
};
declare type ControllerRESTConfig = {
    path: string;
    routes: {
        [method in HttpMethod]?: {
            [route: string]: ControllerRESTRoute;
        };
    };
};
declare const ControllerREST: Controller<ControllerRESTConfig>;
export default ControllerREST;
